<template>
    <div class="app-address-cascader">
        <el-cascader
            popper-class="app-address-cascader__popper-class"
            :disabled="disabled"
            size="medium"
            :placeholder="placeholder"
            v-model="CurrentVal"
            :options="items"
            :separator="separator"
            :show-all-levels="showAllLevels"
            :props="{ multiple: multiple }"
            :filterable="filterable"
            @visible-change="onChange"
        >
        </el-cascader>
    </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import CodeListService from "@/codelist/codelist-service";
@Component({})
export default class AppAddressCascader extends Vue {
    /**
     * 属性名称
     *
     * @type {*}
     * @memberof AppAddressCascader
     */
    @Prop() name?: any;

    /**
     * 传入值
     * @type {any}
     * @memberof AppAddressCascader
     */
    @Prop() public value?: any;

    /**
     * 是否禁用
     * @type {boolean}
     * @memberof AppAddressCascader
     */
    @Prop() public disabled?: boolean;

    /**
     * 代码表标识
     *
     * @type {string}
     * @memberof AppAddressCascader
     */
    @Prop() public tag?: string;

    /**
     * 局部上下文导航参数
     *
     * @type {any}
     * @memberof AppAddressCascader
     */
    @Prop() public localContext!: any;

    /**
     * 局部导航参数
     *
     * @type {any}
     * @memberof AppAddressCascader
     */
    @Prop() public localParam!: any;

    /**
     * 传入表单数据
     *
     * @type {*}
     * @memberof AppAddressCascader
     */
    @Prop() public data?: any;

    /**
     * 视图上下文
     *
     * @type {*}
     * @memberof AppAddressCascader
     */
    @Prop() public context!: any;

    /**
     * 代码表类型
     *
     * @type {string}
     * @memberof AppAddressCascader
     */
    @Prop() public codelistType?: string;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof AppAddressCascader
     */
    @Prop() public viewparams!: any;

    /**
     * 占位提示
     *
     * @type {string}
     * @memberof AppAddressCascader
     */
    @Prop() public placeholder?: string;

    /**
     * 显示label值
     *
     * @type {string}
     * @memberof AppAddressCascader
     */
    @Prop({ default: "label" }) public label?: string;

    /**
     * 节点叶子值
     *
     * @type {string}
     * @memberof AppAddressCascader
     */
    @Prop({ default: "value" }) public itemvalue?: string;

    /**
     * 排序
     *
     * @type {string}
     * @memberof AppAddressCascader
     */
    @Prop({ default: "desc" }) public desc?: string;

    /**
     * 单多选
     *
     * @type {boolean}
     * @memberof AppAddressCascader
     */
    @Prop() public multiple?: boolean;

    /**
     * 连接符
     *
     * @type {string}
     * @memberof AppAddressCascader
     */
    @Prop() public separator?: string;

    /**
     * 是否可过滤，即是否可搜索
     *
     * @type {boolean}
     * @memberof AppAddressCascader
     */
    @Prop() public filterable?: boolean;

    /**
     * 是否展示选中数据完整路径
     *
     * @type {boolean}
     * @memberof AppAddressCascader
     */
    @Prop() public showAllLevels?: boolean;

    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof AppAddressCascader
     */
    public codeListService: CodeListService = new CodeListService();

    /**
     * 当前值
     *
     * @memberof AppAddressCascader
     */
    get CurrentVal() {
        if (this.value) {
            try {
                return JSON.parse(this.value);
            } catch {
                return null;
            }
        }
        return this.value;
    }

    /**
     * 值变化
     *
     * @memberof AppAddressCascader
     */
    set CurrentVal(val: any) {
        const value = JSON.stringify(val);
        this.$emit("change", { name: this.name, value: value });
    }

    /**
     * 级联数据
     *
     * @memberof AppAddressCascader
     */
    public items: any = [];

    /**
     * 获取树形代码表数据
     *
     * @memberof AppAddressCascader
     */
    public load() {
        if (this.tag) {
            if (Object.is(this.codelistType, "STATIC")) {
                const codelist = this.$store.getters.getCodeList(this.tag);
                if (codelist) {
                    this.formatData([
                        ...JSON.parse(JSON.stringify(codelist.items)),
                    ]);
                } else {
                    console.warn(`${this.tag}--代码表配置异常`);
                }
            } else if (Object.is(this.codelistType, "DYNAMIC")) {
                // 公共参数处理
                let data: any = {};
                this.handlePublicParams(data);
                // 参数处理
                let _context = data.context;
                let _param = data.param;
                this.codeListService
                    .getItems(this.tag, _context, _param)
                    .then((res: any) => {
                        this.formatData([...JSON.parse(JSON.stringify(res))]);
                    })
                    .catch((error: any) => {
                        console.error(error);
                    });
            }
        }
    }

    /**
     * 公共参数处理
     *
     * @param {*} arg
     * @returns
     * @memberof AppAddressCascader
     */
    public handlePublicParams(arg: any) {
        // 合并表单参数
        arg.param = this.viewparams
            ? JSON.parse(JSON.stringify(this.viewparams))
            : {};
        arg.context = this.context
            ? JSON.parse(JSON.stringify(this.context))
            : {};
        // 附加参数处理
        if (this.localContext && Object.keys(this.localContext).length > 0) {
            let _context = this.$util.computedNavData(
                this.data,
                arg.context,
                arg.param,
                this.localContext
            );
            Object.assign(arg.context, _context);
        }
        if (this.localParam && Object.keys(this.localParam).length > 0) {
            let _param = this.$util.computedNavData(
                this.data,
                arg.context,
                arg.param,
                this.localParam
            );
            Object.assign(arg.param, _param);
        }
        if (this.desc) {
            Object.assign(arg.param, { desc: this.desc });
        }
    }

    /**
     * 展开面板
     *
     * @param {boolean}
     * @returns
     * @memberof AppAddressCascader
     */
    public onChange(value: boolean) {
        if (value) {
            this.load();
        }
    }

    /**
     * 格式化代码表
     *
     * @param {array}
     * @returns
     * @memberof AppAddressCascader
     */
    public formatData(data: any[]) {
        if (data.length == 0) {
            this.items = [];
        } else {
            this.items = this.handleChildren(undefined, data);
        }
    }

    /**
     * 处理父子层级
     * @param pValue
     * @param data
     * @memberof AppAddressCascader
     */
    public handleChildren(pValue: any, data: any) {
        let tempData: any[] = [];
        let childData: any[] = [];
        if (data.length == 0) {
            return [];
        }
        data.forEach((item: any) => {
            item.value = item[this.itemvalue!];
            item.label = item[this.label!];
            if (pValue == item.pvalue) {
                tempData.push(item);
            } else {
                childData.push(item);
            }
        });

        tempData.forEach((item: any) => {
            const children = this.handleChildren(item.value, childData);
            if (children.length == 0) {
                return;
            }
            if (item.children) {
                item.children.push(...children);
            } else {
                item.children = children;
            }
        });
        return tempData;
    }

    /**
     * 生命周期
     *
     * @memberof AppAddressCascader
     */
    public created() {
        this.load();
    }
}
</script>